// InfoServer.java

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.net.*;



public class InfoServer extends Thread
  {
  public String[] nomeServer = new String[10];
  public int[] carico=new int[10];
  public int numeroNodi;
  public int mioNodo;
  public int gap;
  public int fasciaDiCarico;
  
/////////////////////////////////////////////////////////////////////////////////
//      
//  RICEVI AGGIORNAMENTO
//      
/////////////////////////////////////////////////////////////////////////////////  
  
   public void run()
  	{
  	int valoreCarico;

  	try
  		{	
		  DatagramSocket socket = new DatagramSocket(4485);
		  
	  	byte[] buf = new byte[256];
	  	
	  	for(;;)
  			{
				DatagramPacket packet= new DatagramPacket(buf, buf.length);
				System.out.println("---------->Attendo packet");
				socket.receive(packet);
				System.out.println("---------->Ricevuto packet");
				InetAddress address = packet.getAddress();
				String nomeNodo=new String(address.getHostName());
				String stringaCarico = new String(packet.getData(),0,packet.getLength());
				valoreCarico = Integer.parseInt(stringaCarico);
				
				this.aggiornaCarico(nomeNodo,valoreCarico);
  			}	
  		}
 		catch (SocketException se)
  		{
  		}
  	catch	(IOException io)
  		{
  		}
    }  		           
  
/////////////////////////////////////////////////////////////////////////////////
//      
//  AGGIORNA CARICO
//      
/////////////////////////////////////////////////////////////////////////////////  
  
  public synchronized  void aggiornaCarico(String nomeNodo, int valoreCarico)
  	{
		boolean trovato=false;
   	int n=0;
   
  	while (trovato==false)
  		{
  			
  		if (nomeNodo.compareToIgnoreCase(nomeServer[n])==0)
  			{	
  			trovato=true;
  			carico[n]=valoreCarico;
  			System.out.println("Aggiornato nodo "+nomeNodo+" al carico "+valoreCarico);
				System.out.println();
				};
		  n++;
  		};
  	stampaStatoDeiServer();
		};
		
/////////////////////////////////////////////////////////////////////////////////
//      
//  DO MULTICAST
//      
/////////////////////////////////////////////////////////////////////////////////        
    
  public void doMulticast(int valore)
	  {
	  int porta;
		InetAddress indirizzo;
		DatagramSocket socket = null;
		DatagramPacket pacchetto;
		byte[] bufferInvio = new byte[256];

		String stringValore = Integer.toString(valore); 
		bufferInvio=stringValore.getBytes();
		try
	  	{
	    socket = new DatagramSocket();
	    int n; 
	    for (n=0;n<numeroNodi;n++)
		  	{
		  	if (n!=mioNodo)
		  		{
			    indirizzo = InetAddress.getByName(nomeServer[n]);

			    String ipAdd = new String(indirizzo.toString());
			    System.out.println("Server a cui mando il messaggio");
					System.out.println(nomeServer[n]);
					System.out.println("********************");  
 					pacchetto = new DatagramPacket(bufferInvio, bufferInvio.length, indirizzo, 4485);
 					
					socket.send(pacchetto);
					socket.close();
		  		}
		  	}
		  }
	  catch(SocketException se)
	  	{
	  	}
  	catch(IOException io)
	  	{
	  	}
	  }

///////////////////////////////////////////////////////////////////////////////
//
// STAMPA STATO DEI SERVER
//
///////////////////////////////////////////////////////////////////////////////

  public void stampaStatoDeiServer()
  	{
  	int n;
  	System.out.println("********************");
   	System.out.println("Stampo lo stato dei Server:");
		for(n=0;n<=1;n++) 	
   		{
   		System.out.print("Nome Server: "+nomeServer[n]);
   		System.out.println(" Livello del Carico: "+carico[n]);
      }
    System.out.println("********************");  
  	}			  	  
  }
	
	
	 